uses zvidview, dos;

const timer = $1c;

var

  nam: string;

  vid_array: pointer;

  i: word;
  nextframe: bytebool;


  oldinit: pointer;

  palette_pointer: pointer;

  pal_length: word;

  keypressed: bytebool;

procedure load_palette(n: string);
var
  f: file;
begin
  assign(f, n);
  {$I-}
  reset(f, 1);
  {$I+}
  if ioresult <> 0 then
  begin
    writeln(nam+'.pal nicht gefunden!');
    halt(1);
  end;
  blockread(f, pal_length, 2);
  getmem(palette_pointer, pal_length * 3);
  blockread(f, palette_pointer^, 3 * pal_length);
  close(f);
end;


procedure set_pal;
begin

  asm

    mov ax, 1012h
    xor bx, bx
    mov cx, pal_length
    les si, palette_pointer
    mov dx, si
    int 10h

  end;

end;


procedure enable_nextframe; interrupt;
begin
  nextframe := true;
  setintvec(timer, oldinit);
  asm int timer end;
  setintvec(timer, @enable_nextframe)
end;



procedure screen_update; assembler;
asm
  push ds

  lds si, vid_array
  mov ax, 0a000h
  mov es, ax
  xor di, di

  mov cx, 32000
  rep movsw

  pop ds
end;

label ende;

begin

  if paramstr(1) = '' then
  begin
    writeln;
    writeln('ZVID Grafikformat 1.0 Demo     by Zatzen 2014');
    writeln;
    write('Video (ohne Dateierweiterung): ');
    readln(nam);
  end
  else
    nam := paramstr(1);

  load_palette(nam+'.pal');


  getmem(vid_array, 64000);

  init_zvid(1, 320, 200, vid_array);


  if load_zvid(nam+'.zvd', 0) <> 0 then
  begin
    writeln(nam+'.zvd nicht gefunden!');
    halt(1);
  end;

  asm
    mov ax, 13h
    int 10h
  end;


  set_pal;



  asm cli end;
  getintvec(timer, oldinit);
  setintvec(timer, @enable_nextframe);
  asm sti end;

  zvid_putframe(0, 0, 0, 0);
  screen_update;

  for i := 0 to 9 do { ein wenig warten, fr rhrenbildschirme }
  begin

    repeat until nextframe;
    nextframe := false;

  end;

  repeat
  for i := 0 to zvid_frames(0) - 1 do
  begin
    zvid_putframe(0, i, 0, 0);

    screen_update;

    asm
      mov ax, 0b00h
      int 21h
      mov keypressed, al
    end;

    if keypressed then goto ende;

    repeat until nextframe;
    nextframe := false;

  end;
  until false;


  ende:

  asm
    mov ax, 3
    int 10h
  end;

  asm cli end;
  setintvec(timer, oldinit);
  asm sti end;

end.